<?php

class Autores 
{      

  private $conexao;
  private $queryStr;
  
  // construtor
  function __construct() 
  {   
    // cria a conexão com o MySQL
    $this->conexao = new mysqli("localhost", "edson", "integrator",
                                "livraria");
	
  }

  // destrutor, fecha a conexão com o banco de dados  
  function __destruct() 
  {
    $this->conexao->close();
  }
  // gera o XML que o GRID irá ler
  public function geraXML()
  {
    // cria a query que resultará nos dados
    $queryStr = $this->setQuery('autor_id,nome,email,  
									DATE_FORMAT(dt_nasc,\'%d/%m/%Y\') 
									as nascimento', 'autores');
 
 
    $XML="\n<autores>\n";
	$result = $this->getResults();
     while ( $row = $result->fetch_assoc() ) {
        $XML.="<autor>\n";
        $XML.="<codigo>" . $row["autor_id"] . "</codigo>\n";
        $XML.="<nome>" . stripslashes( $row["nome"] ) . "</nome>\n";
        $XML.="<email>" . stripslashes( $row["email"] ) . "</email>\n";
        $XML.="<nascimento>" . stripslashes( $row["nascimento"] ) . "</nascimento>\n";
        $XML.="</autor>\n";
     }
    $XML.="</autores>";
	
	return $XML; //retorna o XML gerado
  }
  
  // converte a data de dia/mês/ano para ano-mês-dia
  private function converteData($data)
  {
  	
	$dt_conv = preg_replace("'^([0-9]{2})/([0-9]{2})/([0-9]{4})$'",
												'$3-$2-$1',$data);
	return $dt_conv;	
  }

  // atualiza os dados
  public function atualizar($id, $nome, $email, $dt_nasc)
  {
    $id = $this->conexao->real_escape_string($id);
    $nome = $this->conexao->real_escape_string($nome);
    $email = $this->conexao->real_escape_string($email);
 	$dt = $this->converteData($dt_nasc);

    // constroe a SQL Update para atualizar os dados
    $query =  "UPDATE autores SET nome='$nome',  
								  email= '$email' ,  
								  dt_nasc= '$dt'  
							  WHERE autor_id=$id";        
    // executa o comando SQL      
    return $this->conexao->query($query);  
  }
  // insere os dados 
  public function inserir($nome, $email, $dt_nasc)
  {
    $nome = $this->conexao->real_escape_string($nome);
    $email = $this->conexao->real_escape_string($email);
 	$dt = $this->converteData($dt_nasc);
	
    // constroe a SQL Insert para inserir os dados
    $query =  "INSERT INTO autores VALUES (null,'$nome',  
								  '$email','$dt')";        
    // executa o comando SQL      
    return $this->conexao->query($query);

  
  }
  // exclui os dados
  public function excluir($id)
  {
    // constroe a SQL Delete para excluir os dados
    $query =  "DELETE FROM autores WHERE autor_id=$id";       
    // executa o comando SQL     
    return $this->conexao->query($query);  
  }  
  
  // método que gera o XML de confirmação
  public function confirma()
  {
  	return "\n<exc><result>SUCESS</result></exc>";
  
  }
  
  // método que desenvolve Selects
  private function setQuery($colunas, $tabela, $where='') 
  {
  	$this->queryStr="SELECT $colunas FROM $tabela";
  
    // caso haja uma condição Where na query  
    if (!empty($where)) 
		$this->queryStr .= " WHERE $where";

  } 
  
  // método que pega os resultados gerados por setQuery
  private function getResults()
  {
	$result = $this->conexao->query($this->queryStr);
	return $result;
  
  }
  
// fim da classe 
} 
?>
