// armazena a referencia ao objeto XMLHttpRequest
var xmlHttp = criaXmlHttpRequestObject();
// o nome do arquivo XSLT
var arqXslt = "autores.xsl";
// o nome do arquivo que retorna o formato XML
var paginaResult = "autores.php";
 
// o id da tabela
var tabelaDivId = "conteudo";

// o documento XSLT 
var stylesheetDoc;

// o ID do autor em edio
var codEmEdicao = null;

// armazena dados temporarios
var dadosTemp;
// verifica se est ou no inserida uma linha para cadastro
var estaInserida = false;

// a funo que inicia tudo
function init()
{
  // testa se o browser tem funcionalidade nativa para XSLT
  if(window.XMLHttpRequest && window.XSLTProcessor && window.DOMParser)
  {
    // carrega a tabela
    carregarStylesheet();
    carregarTabela();
    return;
  }
  // testa se o Internet Explorer suporta XSLT 
  if (window.ActiveXObject)
  {
    // carrega a tabela
    carregarStylesheet();
    carregarTabela();
    // sai da funo
    return;  
  }
  // se houver uma falha
  alert("Seu browser no tem a funcionalidade necessria para executar.");
}

function criaMsxml2DOMDocumentObject()
{

  var msxml2DOM;
  // verifica a verso MSXML que seu browser vai trabalhar
  var msxml2DOMDocumentVersoes =  [ "Msxml2.DOMDocument.6.0","Msxml2.DOMDocument.5.0",
        			"Msxml2.DOMDocument.4.0"," Msxml2.DOMDocument.3.0",
        			"Msxml2.DOMDocument"," Microsoft.XmlDom"
   			 ];


  // procura o melhor objeto MSXML
  for (var i=0; i<msxml2DOMDocumentVersoes.length; i++) 
  {
    try 
    { 
      msxml2DOM = new ActiveXObject(msxml2DOMDocumentVersoes[i]);
    } 
    catch (e) {}
  }
  // retorna o objeto criado ou retorna um erro
  if (!msxml2DOM)
    alert("Erro ao tentar criar um objeto MSXML");
  else 
    return msxml2DOM;
}

// cria uma instancia XMLHttpRequest 
function criaXmlHttpRequestObject() 
{
  
  var xmlHttp;
 
  // trabalha com todos os browsers, menos IE
  try
  {
    // tenta criar o objeto XMLHttpRequest
    xmlHttp = new XMLHttpRequest();
  }
  catch(e)
  {
    var XmlHttpVersoes = [ "MSXML2.XMLHTTP.6.0","MSXML2.XMLHttp.5.0",
		"MSXML2.XMLHttp.4.0","MSXML2.XMLHttp.3.0",
		"MSXML2.XMLHttp","Microsoft.XMLHttp"
		];

    // procura a melhor verso para o IE
    for (var i=0; i<XmlHttpVersoes.length; i++) 
    {
      try 
      { 
        //tenta criar o objeto XMLHttpRequest 
        xmlHttp = new ActiveXObject(XmlHttpVersoes[i]);
      } 
      catch (e) {}
    }
  }
  //retorna o objeto criado ou um erro
  if (!xmlHttp)
    alert("Erro ao tentar criar um objeto XMLHttpRequest.");
  else 
    return xmlHttp;
}

// carrega o stylesheet do servidor usando modo sincrono
function carregarStylesheet()
{
  // carrega o arquivo do servidor
  xmlHttp.open("GET", arqXslt, false);        
  xmlHttp.send(null);    

  if (this.DOMParser) // browsers com funcionalidade nativa
  {
    var dp = new DOMParser();
    stylesheetDoc = dp.parseFromString(xmlHttp.responseText, "text/xml");
  } 
  else if (window.ActiveXObject) // IE 
  {
    stylesheetDoc = criaMsxml2DOMDocumentObject();         
    stylesheetDoc.async = false;         
    stylesheetDoc.load(xmlHttp.responseXML);
  }
}

// carrega a tabela pegando os dados existentes no arquivo de modo assincrono
function carregarTabela()
{
  
  // continua somente se o objeto XMLHttpRequest no der problema
  if (xmlHttp && (xmlHttp.readyState == 4 || xmlHttp.readyState == 0))
  {
    var query = paginaResult;
    xmlHttp.open("GET", query, true);
    xmlHttp.onreadystatechange = geraTabela;
    xmlHttp.send(null);
  }  
}
 
// funo que capta os resultados do servidor e cria a tabela
function geraTabela()
{
  // se readyState  4, l a resposta do servidor
  if (xmlHttp.readyState == 4)
  {
    // continua somente se o status for 200
    if (xmlHttp.status == 200)
    {    
      // le a resposta
      resposta = xmlHttp.responseText;
      // erro no servidor?
      if (resposta.indexOf("ERRNO") >= 0 
          || resposta.indexOf("error") >= 0
          || resposta.length == 0)
      {
        // mostra a mensagem de erro
        alert(resposta.length == 0 ? "Erro no servidor." : resposta);
        // sai da funo
        return;
      }
      // o servidor respondeu em formato XML
      respostaXml = xmlHttp.responseXML;        
      //Mozilla...  
      if (window.XMLHttpRequest && window.XSLTProcessor && 
          window.DOMParser)
      {      
        // carrega o documento XSLT
        var xsltProcessor = new XSLTProcessor();
        xsltProcessor.importStylesheet(stylesheetDoc);
        // gera o cdigo HTML
        pagina = xsltProcessor.transformToFragment(respostaXml, document);
        // mostra a pgina gerada
        var tabelaDiv = document.getElementById(tabelaDivId);
        tabelaDiv.innerHTML = "";
        tabelaDiv.appendChild(pagina);
      } 
      // IE
      else if (window.ActiveXObject) 
      {
        // carrega o documento XSLT
        var documento = criaMsxml2DOMDocumentObject();
        documento.async = false;
        documento.load(respostaXml);
        // mostra os resultados gerando a pgina
        var tabelaDiv = document.getElementById(tabelaDivId);
        tabelaDiv.innerHTML = documento.transformNode(stylesheetDoc);
      }
    } 
    else 
    {          
      alert("Erro na leitura da resposta pelo servidor.")
    }
  } 
}
 
// exclui uma linha
function excRow(id)
{  
  var rw = document.getElementById(id);
  // altera a cor da linha que est para excluir
  rw.className='rowSel';
  // cancela a linha a ser incluida, se houver alguma
  if(estaInserida) deleteRow(0);
  // cancela se houver uma linha em edio
  if(codEmEdicao) editarLinha(codEmEdicao, false);
  
  if (xmlHttp && (xmlHttp.readyState == 4 || xmlHttp.readyState == 0))
  {  
    // exibe uma mensagem de confirmao
    if(confirm("Deseja excluir esse cadastro?")){
		var query = paginaResult + "?acao=EXC_ROW&id=" + id;
		xmlHttp.open("GET", query, true);
		// verifica a resposta dada pelo servidor
		xmlHttp.onreadystatechange = dadosExcluidos;
	
		xmlHttp.send(null);
	}
	else
		rw.className='row';
  } 
}
// recebe o resultado do servidor
function dadosExcluidos()
{ 
  if(xmlHttp.readyState == 1) {
	// exibe a mensagem de carregando  
	mensagem( "Carregando...", true );   
  }
  if(xmlHttp.readyState == 4)
  {
    if(xmlHttp.status == 200)
    {
      // l a resposta
      resposta = xmlHttp.responseXML;
      var exc = resposta.getElementsByTagName("exc");
      var result = exc[0].getElementsByTagName("result")[0].firstChild.nodeValue;
      // se a resposta estiver correta, foi excluido com sucesso
      if(result=="SUCESS"){
		// recarrega a tabela para exibir os dados atuais
    	carregarStylesheet();
    	carregarTabela();
		mensagem( "", false );
		// mostra uma mensagem avisando
		alert("Dados excluidos com sucesso");
     }
     else
	alert("Erro ao excluir");
     
    }
  } 

}	
	
function editarLinha(id, editar)
{  

  // pega a linha que voc deseja editar
  var rw = document.getElementById(id);
  // altera a cor da linha em edio
  rw.className='rowSel';
  var linhaEditada = rw.cells; 
  
  // est em modo de edio?
  if(editar)
  {
	
	if(codEmEdicao) editarLinha(codEmEdicao, false);
	if(estaInserida) deleteRow(0);
    // armazena os dados atuais caso voc cancele a edio
    salvar(id);    
    // cria os campos de texto editveis
    linhaEditada[1].innerHTML = 
         '<input class="nome" type="text" name="nome" ' + 
         'value="' + linhaEditada[1].innerHTML+'">';   
    linhaEditada[2].innerHTML = 
         '<input class="email" type="text" name="email" ' + 
         'value="' + linhaEditada[2].innerHTML+'">';  
	linhaEditada[3].innerHTML = 
         '<input class="data" type="text" name="data" ' + 
         'value="' + linhaEditada[3].innerHTML+'">';
    linhaEditada[4].innerHTML = '<a href="#" ' + 
         'onclick="atualizar(document.forms.formulario,' + id + 
         ')"><img src="images/confirm.gif" border="0" alt="Atualizar" /></a><a href="#" ' + 
         'onclick="desfazer(' + id + 
         ')"><img src="images/cancel.png" border="0" alt="Cancelar" /></a>';
    // armazena o id no qual voc est editando
    codEmEdicao = id;
	
	mascarar();
  }
  // se voc retirar o modo de edio
  else
  {   
    // caso cancele, retorna a cor da linha ao original
  	rw.className='row';
    linhaEditada[1].innerHTML = document.forms.formulario.nome.value; 
    linhaEditada[2].innerHTML = document.forms.formulario.email.value;
    linhaEditada[3].innerHTML = document.forms.formulario.data.value;     
    linhaEditada[4].innerHTML = '<a href="#" onclick="editarLinha(' + id +  
                               ',true)">'+
								'<img src="images/edit.gif" border="0" '+
								'alt="Editar Cadastro" /></a>';
    // esvazia o id usado para edio    
    codEmEdicao = null;
  }
}

// salva os dados originais atuais
function salvar(id)
{

  var tr = document.getElementById(id).cells;
  // salva os dados em uma varivel temporria
  dadosTemp = new Array(tr.length); 
  for(var i=0; i<tr.length; i++)   
    dadosTemp[i] = tr[i].innerHTML;   
}

// cancela a edio e retorna os dados anteriores
function desfazer(id)
{

  var rw = document.getElementById(id);
  rw.className='row';
  var tr = rw.cells;
  for(var i=0; i<dadosTemp.length; i++) 
    tr[i].innerHTML = dadosTemp[i];
  // linha sem edio 
  codEmEdicao = null;    
}	
// mtodo que guarda a cor da linha atual
function backgColor(id){
  var rw = document.getElementById(id);
  var corAtual=rw.getAttribute('bgcolor');
  
	
}

// insere uma linha a tabela para inserir dados
function insRow()
{
	// se j est em edio uma linha
	// desativa a edio para inserir um registro
	if(codEmEdicao) editarLinha(codEmEdicao, false);
   // verifica se j existe uma linha para ser inserida	 
   // caso haja, mostra uma mensagem
   if(estaInserida)
		alert('J existe uma linha para ser inserida'); 
   else{
	    // se no houver, cria um linha acima de todas
		var linha=document.getElementById('dados').insertRow(0);
		linha.className='rowSel';
		var cel1=linha.insertCell(0);
		var cel2=linha.insertCell(1);
		var cel3=linha.insertCell(2);
		var cel4=linha.insertCell(3);
		var cel5=linha.insertCell(4);
		var cel6=linha.insertCell(5);
		// gera os campos da nova linha
		cel1.innerHTML='*';
		cel2.innerHTML='<input class="nome" type="text" name="nome" value="">';
		cel3.innerHTML='<input class="email" type="text" name="email" value="">';
		cel4.innerHTML='<input class="data" type="text" name="data" value="">';
		cel5.innerHTML='<a href="#" ' + 
			 'onclick="cadastrar(document.forms.formulario)">'+
			 '<img src="images/save.gif" border="0" alt="Salvar Cadastro" /></a> ';
		cel6.innerHTML=	 '<a href="#" ' + 
			 'onclick="deleteRow(0)">'+
			 '<img src="images/cancel.png" border="0" alt="Cancelar" /></a>';
		//cel5.colSpan='2';//comentado do original do livro
		// muda o status da linha para true, 
		//indicando que existe uma linha para ser inserida
		estaInserida=true;
		mascarar();
   }
		
}
// mtodo que mostra a mensagem de loading
function mensagem(msg, mostrar)
{
	var st = document.getElementById('status');	
	var vis = null;
	if(mostrar)
		vis='visible';
	else
		vis='hidden';
	st.style.visibility=vis;
	st.innerHTML=msg;
}

// mtodo responsvel por excluir a linha nova
// caso venha a ser cancelada, na insero
function deleteRow(linha)
{
	document.getElementById('dados').deleteRow(linha);
	estaInserida=false;
}

// mtodo que cadastra os dados novos
function cadastrar(formulario)
{
  if (xmlHttp && (xmlHttp.readyState == 4 || xmlHttp.readyState == 0))
  {  
	//pega os dados selecionados
	var dados = getDadosForm(formulario);
	//concatena com a acao de inserir
	dados+="&acao=INS_ROW";
	//o mtodo de submisso   POST
	xmlHttp.open("POST", paginaResult, true);
	xmlHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;");
 
	// verifica a resposta dada pelo servidor
	xmlHttp.onreadystatechange = getResultado;
	//submete
	xmlHttp.send(dados);
  } 
}

// mtodo que atualiza os dados existentes
function atualizar(formulario,id)
{
  if (xmlHttp && (xmlHttp.readyState == 4 || xmlHttp.readyState == 0))
  {  
	//pega os dados selecionados
	var dados = getDadosForm(formulario);
	//concatena com a acao de atualizao
	dados+="&acao=UPDATE_ROW&id="+id;
	//o mtodo de submisso  POST
	xmlHttp.open("POST", paginaResult, true);
	xmlHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	// verifica a resposta dada pelo servidor
	xmlHttp.onreadystatechange = getResultado;
	//submete
	xmlHttp.send(dados);
  } 
}
// mtodo que pega o resultado dado pelo servidor
function getResultado()
{
  // caso ainda esteja em leitura	
  if(xmlHttp.readyState == 1) {
	//exibe a mensagem de carregando
	mensagem( "Carregando...", true );   
  }
  else if(xmlHttp.readyState == 4)
  {
    if(xmlHttp.status == 200)
    {
      // l a resposta
      resposta = xmlHttp.responseXML;
      var exc = resposta.getElementsByTagName("exc");
      var result = exc[0].getElementsByTagName("result")[0].firstChild.nodeValue;
      // se a resposta estiver correta, foi excluido com sucesso
      if(result=="SUCESS"){
		// altera a varivel caso esteja em edio  
		codEmEdicao = null;  
		//altera a varivel caso esteja em atualizao
		estaInserida=false;
		// recarrega a tabela para exibir os dados atuais
    	//carregarStylesheet();
    	carregarTabela();
		// retira a mensagem
		mensagem( "", false );
     }
     else
		alert("Erro ao Inserir");
     
    }
  } 	
	
}

// mtodo usado para tratar os dados do formulrio
function getDadosForm(objForm) {
    var params = new Array();
    // varre os elementos do formulrio
    for (var i=0 ; i < objForm.elements.length; i++) {
        var parametro = objForm.elements[i].name;
        parametro += "=";
        parametro += encodeURIComponent(objForm.elements[i].value);
        params.push(parametro);
    }
	// retorna os campos e valores encontrados
    return params.join("&");
}
function mascarar()
{
	oDateMask = new Mask("dd/mm/yyyy", "date");
	oDateMask.attach(document.getElementById('formulario').data);	
}