// armazena a referencia ao objeto XMLHttpRequest
var xmlHttp = criaXmlHttpRequestObject();
// o nome do arquivo XSLT
var arqXslt = "autores.xsl";
// o nome do arquivo que retorna o formato XML
var paginaResult = "autores.jsp";
 
// o id da tabela
var tabelaDivId = "conteudo";

// o documento XSLT 
var stylesheetDoc;

// a funo que inicia tudo
function init()
{
  // testa se o browser tem funcionalidade nativa para XSLT
  if(window.XMLHttpRequest && window.XSLTProcessor && window.DOMParser)
  {
    // carrega a tabela
    carregarStylesheet();
    carregarTabela();
    return;
  }
  // testa se o Internet Explorer suporta XSLT 
  if (window.ActiveXObject)
  {
    // carrega a tabela
    carregarStylesheet();
    carregarTabela();
    // exit the function
    return;  
  }
  // se houver uma falha
  alert("Seu browser no tem a funcionalidade necessria para executar.");
}

function criaMsxml2DOMDocumentObject()
{

  var msxml2DOM;
  // verifica a verso MSXML que seu browser vai trabalhar
  var msxml2DOMDocumentVersoes =  [ "Msxml2.DOMDocument.6.0","Msxml2.DOMDocument.5.0",
        			"Msxml2.DOMDocument.4.0"," Msxml2.DOMDocument.3.0",
        			"Msxml2.DOMDocument"," Microsoft.XmlDom"
   			 ];


  // procura o melhor objeto MSXML
  for (var i=0; i<msxml2DOMDocumentVersoes.length; i++) 
  {
    try 
    { 
      msxml2DOM = new ActiveXObject(msxml2DOMDocumentVersoes[i]);
    } 
    catch (e) {}
  }
  // retorna o objeto criado ou retorna um erro
  if (!msxml2DOM)
    alert("Erro ao tentar criar um objeto MSXML");
  else 
    return msxml2DOM;
}

// cria uma instancia XMLHttpRequest 
function criaXmlHttpRequestObject() 
{
  
  var xmlHttp;
 
  // trabalha com todos os browsers, menos IE
  try
  {
    // tenta criar o objeto XMLHttpRequest
    xmlHttp = new XMLHttpRequest();
  }
  catch(e)
  {
    var XmlHttpVersoes = [ "MSXML2.XMLHTTP.6.0","MSXML2.XMLHttp.5.0",
		"MSXML2.XMLHttp.4.0","MSXML2.XMLHttp.3.0",
		"MSXML2.XMLHttp","Microsoft.XMLHttp"
		];

    // procura a melhor verso para o IE
    for (var i=0; i<XmlHttpVersoes.length; i++) 
    {
      try 
      { 
        //tenta criar o objeto XMLHttpRequest 
        xmlHttp = new ActiveXObject(XmlHttpVersoes[i]);
      } 
      catch (e) {}
    }
  }
  //retorna o objeto criado ou um erro
  if (!xmlHttp)
    alert("Erro ao tentar criar um objeto XMLHttpRequest.");
  else 
    return xmlHttp;
}

// carrega o stylesheet do servidor usando modo sincrono
function carregarStylesheet()
{
  // carrega o arquivo do servidor
  xmlHttp.open("GET", arqXslt, false);        
  xmlHttp.send(null);    

  if (this.DOMParser) // browsers com funcionalidade nativa
  {
    var dp = new DOMParser();
    stylesheetDoc = dp.parseFromString(xmlHttp.responseText, "text/xml");
  } 
  else if (window.ActiveXObject) // IE 
  {
    stylesheetDoc = criaMsxml2DOMDocumentObject();         
    stylesheetDoc.async = false;         
    stylesheetDoc.load(xmlHttp.responseXML);
  }
}

// carrega a tabela pegando os dados existentes no arquivo de modo assincrono
function carregarTabela()
{
  
  // continua somente se o objeto XMLHttpRequest no der problema
  if (xmlHttp && (xmlHttp.readyState == 4 || xmlHttp.readyState == 0))
  {
    var query = paginaResult;
    xmlHttp.open("GET", query, true);
    xmlHttp.onreadystatechange = geraTabela;
    xmlHttp.send(null);
  }  
}
 
// funo que capta os resultados do servidor e cria a tabela
function geraTabela()
{
  // se readyState  4, l a resposta do servidor
  if (xmlHttp.readyState == 4)
  {
    // continua somente se o status for 200
    if (xmlHttp.status == 200)
    {    
      // le a resposta
      resposta = xmlHttp.responseText;
      // erro no servidor?
      if (resposta.indexOf("ERRNO") >= 0 
          || resposta.indexOf("error") >= 0
          || resposta.length == 0)
      {
        // mostra a mensagem de erro
        alert(resposta.length == 0 ? "Erro no servidor." : resposta);
        // sai da funo
        return;
      }
      // o servidor respondeu em formato XML
      respostaXml = xmlHttp.responseXML;        
      //Mozilla...  
      if (window.XMLHttpRequest && window.XSLTProcessor && 
          window.DOMParser)
      {      
        // carrega o documento XSLT
        var xsltProcessor = new XSLTProcessor();
        xsltProcessor.importStylesheet(stylesheetDoc);
        // gera o cdigo HTML
        pagina = xsltProcessor.transformToFragment(respostaXml, document);
        // mostra a pgina gerada
        var tabelaDiv = document.getElementById(tabelaDivId);
        tabelaDiv.innerHTML = "";
        tabelaDiv.appendChild(pagina);
      } 
      // IE
      else if (window.ActiveXObject) 
      {
        // carrega o documento XSLT
        var documento = criaMsxml2DOMDocumentObject();
        documento.async = false;
        documento.load(respostaXml);
        // mostra os resultados gerando a pgina
        var tabelaDiv = document.getElementById(tabelaDivId);
        tabelaDiv.innerHTML = documento.transformNode(stylesheetDoc);
      }
    } 
    else 
    {          
      alert("Erro na leitura da resposta pelo servidor.")
    }
  } 
}
 
// exclui uma linha
function excRow(codigo)
{  
  
  if (xmlHttp && (xmlHttp.readyState == 4 || xmlHttp.readyState == 0))
  {  
    var query = paginaResult + "?acao=EXC_ROW&cod=" + codigo;
    xmlHttp.open("GET", query, true);
    // verifica a resposta dada pelo servidor
    xmlHttp.onreadystatechange = dadosExcluidos;

    xmlHttp.send(null);
  } 
}
// recebe o resultado do servidor
function dadosExcluidos()
{ 

  if(xmlHttp.readyState == 4)
  {
    if(xmlHttp.status == 200)
    {
      // l a resposta
      resposta = xmlHttp.responseXML;
      var exc = resposta.getElementsByTagName("exc");
      var result = exc[0].getElementsByTagName("result")[0].firstChild.nodeValue;
      // se a resposta estiver correta, foi excluido com sucesso
      if(result=="EXC_SUCESS"){
	// mostra uma mensagem avisando
	alert("Excluido com sucesso");
	// recarrega a tabela para exibir os dados atuais
    	carregarStylesheet();
    	carregarTabela();
     }
     else
	alert("Erro ao excluir");
     
    }
  } 

}