<?php
class Tabela
{      
  // o total de pginas encontradas
  private $totalPaginas;
  // o total de linhas
  private $totalLinhas=0;
  // a pgina retornada
  private $pagina;    
  // conexo ao banco de dados
  private $conexao;
  // quantidade de linhas por pgina
  private $linhasPorPagina=5;
  
  
  function __construct() 
  {   

    $this->conexao = new mysqli("localhost", "edson", "integrator",
                                "livraria");
    // chama o mtodo para ter o total de linhas encontradas
    $this->totalLinhas = $this->totalLinhas('isbn','livros');
  }

   
  function __destruct() 
  {
    $this->conexao->close();
  }
  // l a pgina atual
  public function paginaAtual($pagina)
  {
    // chama o mtodo para gerar a consulta
    $sel = $this->gerarConsulta('*','livros', 
                                             $pagina);

	
    // executa a query
    if ($result = $this->conexao->query($sel)) 
    {
	  // gera o XML
	  $XML="<livros>\n";
      while ($row = $result->fetch_array()) 
      {
        $XML.="<livro>\n";
        $XML.="<isbn>" . $row["isbn"] . "</isbn>\n";
        $XML.="<titulo>" . stripslashes( $row["titulo"] ) . "</titulo>\n";
        $XML.="<edicao>" . stripslashes( $row["edicao_num"] ) . "</edicao>\n";
        $XML.="<publicacao>" . stripslashes( $row["ano_publicacao"] ) . "</publicacao>\n";
        $XML.="</livro>\n"; 
      }// end while
	  $XML.="</livros>\n";

	  
                          
      $result->close();
	  
	  return $XML; // retorna o XML
    }       
  }
  
  // mtodo que gera o XML geral
  public function gerarXML(){
     //verifica o nmero de argumentos 
    $numargs = func_num_args( ); 
    //pega os argumentos passados 
    $arg_list = func_get_args( ); 
	
	$XML = "\n<resultados>\n"; 
	// distribui os argumentos passados para gerar o XML
    for ($i = 0; $i < $numargs; $i++){
  		$XML .= $arg_list[$i];
	}
	$XML .= "</resultados>";
 	return $XML;
  }

  // retorna os parmetros para navegao na paginao
  public function parametros_navegacao()
  { 
    // a pgina atual
	$paginaAtual= $this->getPaginaAtual();
	// o valor da pgina anterior
    $anterior = 
    $paginaAtual  == 1 ? '' : $paginaAtual-1;    
    // o nmero da prxima pgina
    $proxima = $this->totalPaginas == $paginaAtual ? 
                 '' : $paginaAtual + 1; 
    // os parmetros feitos em XML
    $XML = "<parametros>\n
           <pagina> {$this->pagina} </pagina>\n
           <total_paginas>{$this->totalPaginas}</total_paginas>\n
           <total_geral>{$this->totalLinhas}</total_geral>\n
           <anterior>$anterior</anterior>\n
           <proxima>$proxima</proxima>\n
		   <ultima>{$this->totalPaginas}</ultima>\n
		   <primeira>1</primeira>\n
		   </parametros>\n";
		   
	return $XML;// retorna os parmetros de paginao
  }


  /* retorna o total de linhas encontradas
   na tabela*/
  private function totalLinhas($colunas, $tabela)
  {
 
    if ($this->totalLinhas==0) 
    {
      // uma query deve ser feita
      $sel = "SELECT $colunas FROM $tabela";

      if ($result = $this->conexao->query($sel)) 
      {
        /* para que seja possvel ter o nmero de linhas
		   retornadas */
        $total = $result->num_rows; 
		
        $result->close();
      }
    }    
    // retorno do total de linhas encontradas
    return $total;
  }         
  
  //cria a query que resultar na limitao de linhas
  private function gerarConsulta($colunas, $tabela, $paginaN) 
  {
  	$sel = "SELECT $colunas FROM $tabela";
    /* verifica se o total de linhas  menor ou igual ao  
		encontrado no valor mximo de linhas por pgina 
		que voc pode ter. Se for menor,  porque ter 
		apenas uma pgina e portanto o total e o nmero 
		de pginas ser apenas um  */
    if ($this->totalLinhas <= $linhasPorPagina) 
    {
      $paginaN = 1;
      $this->totalPaginas = 1;
    }
    /* caso contrrio, voc ter o total de pginas
		calculado pela diviso entre total de linhas
		e linhas possveis por pgina. O resultado
		 arredondado, para que o total de pginas
		seja exato.
	*/
    else 
    {
      $this->totalPaginas = ceil($this->totalLinhas / $this->linhasPorPagina);
	  /*
	  	A instruo LIMIT do MySQL exige que o comeo
		de uma linha seja zero, por isso o nmero da
		pgina  subtraido em um e multiplicado por
		linhas por pgina, para resultar na linha inicial.
	  */
      $linha_inicial = ($paginaN - 1) * $this->linhasPorPagina;   
      $sel .= " LIMIT  $linha_inicial , {$this->linhasPorPagina}";
    }
    // salva o nmero da pgina atual
    $this->setPaginaAtual($paginaN);

    return $sel; //retorna a query
  } 
  
  // mtodo para ter a pgina atual
  private function setPaginaAtual($paginaN){
  	$this->pagina = $paginaN;
  }
  // mtodo que retorna a pgina atual
  private function getPaginaAtual(){ 
  	return $this->pagina;
  }
// fim da classe Tabela
} 
?>
