function PaginarDados()
{

	this.defineDados = function( arqXslt, paginaResult,tabelaDivId)
	{
		// armazena a referencia ao objeto XMLHttpRequest
		this.xmlHttp = this.criaXmlHttpRequestObject();
		// o nome do arquivo XSLT
		this.arqXslt = arqXslt;
		// o nome do arquivo que retorna o formato XML
		this.paginaResult = paginaResult;
	 
		// o id da tabela
		this.tabelaDivId = tabelaDivId;
	
		// o documento XSLT 
		this.stylesheetDoc;
		
		// cria a layer que aparecer o loading
		this.layer = document.createElement("div");
		// o texto do loading
		this.layer.innerHTML="Carregando...";
		// a classe para formatar o loading
		this.layer.className="status";
		// adiciona a layer ao corpo da pgina
		document.body.appendChild(this.layer);
	
		//inicializa o grid
		this.init();
		
		
	}
	
}

// mtodo que inicia tudo
PaginarDados.prototype.init = function ()
{
  // testa se o browser tem funcionalidade nativa para XSLT
  if(window.XMLHttpRequest && window.XSLTProcessor && window.DOMParser)
  {
    // carrega a tabela
    this.carregarStylesheet();
    this.carregarDadosNaPag(1);
    return;
  }
  // testa se o Internet Explorer suporta XSLT 
  if (window.ActiveXObject)
  {
    // carrega a tabela
    this.carregarStylesheet();
    this.carregarDadosNaPag(1);
    // sai da funo
    return;  
  }
  // se houver uma falha
  alert("Seu browser no tem a funcionalidade necessria para executar.");
};

PaginarDados.prototype.criaMsxml2DOMDocumentObject = function ()
{

  var msxml2DOM;
  // verifica a verso MSXML que seu browser vai trabalhar
  var msxml2DOMDocumentVersoes =  [ "Msxml2.DOMDocument.6.0","Msxml2.DOMDocument.5.0",
        			"Msxml2.DOMDocument.4.0"," Msxml2.DOMDocument.3.0",
        			"Msxml2.DOMDocument"," Microsoft.XmlDom"
   			 		];


  // procura o melhor objeto MSXML
  for (var i=0; i<msxml2DOMDocumentVersoes.length; i++) 
  {
    try 
    { 
      msxml2DOM = new ActiveXObject(msxml2DOMDocumentVersoes[i]);
    } 
    catch (e) {}
  }
  // retorna o objeto criado ou retorna um erro
  if (!msxml2DOM)
    alert("Erro ao tentar criar um objeto MSXML");
  else 
    return msxml2DOM;
};

// cria uma instancia XMLHttpRequest 
PaginarDados.prototype.criaXmlHttpRequestObject = function ()
{
  
  var XMLHttp;
 
  // trabalha com todos os browsers, menos IE
  try
  {
    // tenta criar o objeto XMLHttpRequest
    XMLHttp = new XMLHttpRequest();
  }
  catch(e)
  {
    var XmlHttpVersoes = [ "MSXML2.XMLHTTP.6.0","MSXML2.XMLHttp.5.0",
		"MSXML2.XMLHttp.4.0","MSXML2.XMLHttp.3.0",
		"MSXML2.XMLHttp","Microsoft.XMLHttp"
		];

    // procura a melhor verso para o IE
    for (var i=0; i<XmlHttpVersoes.length; i++) 
    {
      try 
      { 
        //tenta criar o objeto XMLHttpRequest 
        XMLHttp = new ActiveXObject(XmlHttpVersoes[i]);
      } 
      catch (e) {}
    }
  }
  //retorna o objeto criado ou um erro
  if (!XMLHttp)
    alert("Erro ao tentar criar um objeto XMLHttpRequest.");
  else 
    return XMLHttp;
};

// carrega o stylesheet do servidor usando modo sincrono
PaginarDados.prototype.carregarStylesheet= function()
{
  var oXmlHttp = this.xmlHttp;
  // carrega o arquivo do servidor
  oXmlHttp.open("GET", this.arqXslt, false);        
  oXmlHttp.send(null);    

  if (window.ActiveXObject) // browsers com funcionalidade nativa
  {
    this.stylesheetDoc = this.criaMsxml2DOMDocumentObject();         
    this.stylesheetDoc.async = false;         
    this.stylesheetDoc.load(this.xmlHttp.responseXML);
  } 
  else
  {    
  	var dp = new DOMParser();
    this.stylesheetDoc = dp.parseFromString(oXmlHttp.responseText, "text/xml");

  }
  
};


PaginarDados.prototype.carregarDadosNaPag = function(paginaNum)
{
  var oXmlHttp = this.xmlHttp;
  var stylesheetDoc = this.stylesheetDoc;
  var tabelaDivId = this.tabelaDivId;
  //atribui this a uma varivel para ter acesso a uma outra funo
  var pai = this;
 	 
  
  if (oXmlHttp && (oXmlHttp.readyState == 4 || oXmlHttp.readyState == 0))
  {
 
    var pagina = this.paginaResult + "?pag=" + paginaNum;
    oXmlHttp.open("GET", pagina, true);
    oXmlHttp.onreadystatechange = function(){
		// caso esteja sendo carregado
		if(oXmlHttp.readyState == 1) {
			// exibe a mensagem de carregando  
			pai.mensagem(true);
			  
		}
		 if (oXmlHttp.readyState == 4)
		  {
			// continua somente se o status for 200
			if (oXmlHttp.status == 200)
			{  
			  pai.mensagem(false);  
			  // le a resposta
			  // o servidor respondeu em formato XML
			  
			  var respostaXml = oXmlHttp.responseXML;        
			  //Mozilla...  
			  if (window.XMLHttpRequest && window.XSLTProcessor && 
				  window.DOMParser)
			  {      
				// carrega o documento XSLT
				var xsltProcessor = new XSLTProcessor();
				
				xsltProcessor.importStylesheet(stylesheetDoc);
				// gera o cdigo HTML
				var pagina = xsltProcessor.transformToFragment(respostaXml, document);
				// mostra a pgina gerada
				var tabelaDiv = document.getElementById(tabelaDivId);
				tabelaDiv.innerHTML = "";
				tabelaDiv.appendChild(pagina);
			  } 
			  // IE
			  else if (window.ActiveXObject) 
			  { 
				// carrega o documento XSLT
				var documento = pai.criaMsxml2DOMDocumentObject();
				documento.async = false;
				documento.load(respostaXml);
				// mostra os resultados gerando a pgina
				var tabelaDiv = document.getElementById(tabelaDivId);
				tabelaDiv.innerHTML = documento.transformNode(stylesheetDoc);
			  }
			} 
			else 
			{          
			  alert("Erro na leitura da resposta pelo servidor.")
			}
		  }		
		 
		
	};

    oXmlHttp.send(null);
	
  }  
};
// mtodo que exibe ou no a mensagem de carregando
PaginarDados.prototype.mensagem=function(mostrar)
{
	var vis = null;
	if(mostrar)
		vis='visible';
	else
		vis='hidden';
	this.layer.style.visibility=vis;
}		